#ifndef SYSTEMAPI_H
#define SYSTEMAPI_H

#include <QObject>

#include <QVariant>
#include <QString>
#include <QStringList>

#include <QThread>
#include <QtConcurrentRun>
#include <QFuture>
#include <QFutureWatcher>

class SystemApi : public QObject
{
    Q_OBJECT
public:
    explicit SystemApi(){}

    // file/dir i/o api
    Q_INVOKABLE QVariant	readFile(const QString& fname);
    Q_INVOKABLE bool		createFile(const QString& filename, const QString& fileContents);
    Q_INVOKABLE bool		setCurrentDir(const QString& dir);
    Q_INVOKABLE QString    currentDir();
    Q_INVOKABLE QString    applicationPath();
    Q_INVOKABLE QString     selectDirectory();
    Q_INVOKABLE QString     selectFile(const QString& caption, const QString& dir);
    Q_INVOKABLE QStringList selectFiles(const QString& caption, const QString& dir);
    Q_INVOKABLE QVariant	ls(const QString& dirname);
    Q_INVOKABLE QVariant    ls(const QString& dirname, bool fileInfo);
    Q_INVOKABLE QString     startProcess(const QString& program, const QStringList& arguments);
    Q_INVOKABLE void		startDetached(const QString& program, const QStringList& arguments, const QString& workingDirectory);

    Q_INVOKABLE bool		openUrlInBrowser(QString str);	// This is useful for opening, e.g., a help page (opens in system default browser)
    Q_INVOKABLE QVariant	getSystemLocale();

private:

signals:

private slots:

};

#endif // SYSTEMAPI_H
